#ifndef HIST_H
#define HIST_H

#include <conio.h>
              
class histogram{
public:
    histogram(int pcount, int pbottom, int pheight, int pleft);
    void setValue(int pvalue, int pcount);
inline void setAxisX(int value) {axisX = value;}
    int getValue(int pcount);
    void draw();
   ~histogram();
private:
    int count;
    int bottom;
    int height;
    int left;
    int *pcolumns;
    int axisX;
};

histogram::histogram(int pcount, int pbottom, int pheight, int pleft)
{
    if (pcount > 0 && pcount < 81)
    {
        count = pcount;
        pcolumns = new int[count];
        for (int i = 0; i < count; i++) pcolumns[i] = 0;
    }
    if (pbottom > 0) bottom = pbottom;
    if (pheight > 0) height = pheight;
    if (pleft > 0) left = pleft;
    axisX = 1;
}

histogram::~histogram()
{
    if (pcolumns != NULL) delete pcolumns;
}

void histogram::draw()
{
    int max=0;
    int ii = 0,f=0;
    for (int i=0;i<count;i++) {if (pcolumns[i]>max) max=pcolumns[i];}

    for (int i = 0; i < count; i++)
    {
        int bound = ((height-1)*pcolumns[i]/max);
l1:     char fill = '';
        for (int j = 0; j < bound; j++)
        {
            gotoxy(ii+left, bottom - j-1);
            putch(fill);
        }
        fill = ' ';
        for (int j = bound; j < height-1; j++)
        {
            gotoxy(ii+left, bottom - j-1);
            putch(fill);
        }
        ii++;
        if ((79-left)/count&&!f) {f = ((79-left)/count-1);goto l1;}
        if (--f) goto l1;
        gotoxy(ii+left, bottom);
        putch('.');

    }
    gotoxy(left, bottom); printf("%d", axisX);
    gotoxy(left+ii-1, bottom); printf("%d",count + axisX);
    gotoxy(left+ii, bottom-1); putch('0');
    gotoxy(left+ii, bottom-height); printf("%d",max);
}

void histogram::setValue(int pvalue, int pcount)
{
    if (pcount > count && pcount < 1) return;
    pcolumns[pcount-1] = pvalue;
}

int histogram::getValue(int pcount)
{
    return pcolumns[pcount-1];
}

#endif